
package net.mcreator.mnthings.entity;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.network.NetworkHooks;
import net.minecraftforge.fml.network.FMLPlayMessages;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.gen.Heightmap;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.Hand;
import net.minecraft.util.DamageSource;
import net.minecraft.network.IPacket;
import net.minecraft.nbt.CompoundNBT;
import net.minecraft.item.SpawnEggItem;
import net.minecraft.item.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.entity.projectile.PotionEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.passive.TameableEntity;
import net.minecraft.entity.ai.goal.SwimGoal;
import net.minecraft.entity.ai.goal.RandomWalkingGoal;
import net.minecraft.entity.ai.goal.OwnerHurtTargetGoal;
import net.minecraft.entity.ai.goal.OwnerHurtByTargetGoal;
import net.minecraft.entity.ai.goal.NearestAttackableTargetGoal;
import net.minecraft.entity.ai.goal.MeleeAttackGoal;
import net.minecraft.entity.ai.goal.LookRandomlyGoal;
import net.minecraft.entity.ai.goal.HurtByTargetGoal;
import net.minecraft.entity.ai.goal.FollowOwnerGoal;
import net.minecraft.entity.SpawnReason;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ILivingEntityData;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.EntitySpawnPlacementRegistry;
import net.minecraft.entity.EntityClassification;
import net.minecraft.entity.Entity;
import net.minecraft.entity.CreatureAttribute;
import net.minecraft.entity.AgeableEntity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.block.material.Material;
import net.minecraft.block.BlockState;

import net.mcreator.mnthings.MnthingsModElements;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@MnthingsModElements.ModElement.Tag
public class BushmanEntity extends MnthingsModElements.ModElement {
	public static EntityType entity = null;
	public BushmanEntity(MnthingsModElements instance) {
		super(instance, 2);
		FMLJavaModLoadingContext.get().getModEventBus().register(this);
	}

	@Override
	public void initElements() {
		entity = (EntityType.Builder.<CustomEntity>create(CustomEntity::new, EntityClassification.CREATURE).setShouldReceiveVelocityUpdates(true)
				.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(CustomEntity::new).size(0.8f, 1.8f)).build("bushman")
						.setRegistryName("bushman");
		elements.entities.add(() -> entity);
		elements.items.add(() -> new SpawnEggItem(entity, -13031920, -16752639, new Item.Properties().group(ItemGroup.MISC))
				.setRegistryName("bushman_spawn_egg"));
	}

	@Override
	public void init(FMLCommonSetupEvent event) {
		for (Biome biome : ForgeRegistries.BIOMES.getValues()) {
			boolean biomeCriteria = false;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("forest")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("wooded_hills")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("wooded_mountains")))
				biomeCriteria = true;
			if (!biomeCriteria)
				continue;
			biome.getSpawns(EntityClassification.CREATURE).add(new Biome.SpawnListEntry(entity, 45, 4, 6));
		}
		EntitySpawnPlacementRegistry.register(entity, EntitySpawnPlacementRegistry.PlacementType.ON_GROUND, Heightmap.Type.MOTION_BLOCKING_NO_LEAVES,
				(entityType, world, reason, pos,
						random) -> (world.getBlockState(pos.down()).getMaterial() == Material.ORGANIC && world.getLightSubtracted(pos, 0) > 8));
	}

	@SubscribeEvent
	@OnlyIn(Dist.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(entity, renderManager -> {
			return new MobRenderer(renderManager, new ModelBushman(), 0.5f) {
				@Override
				public ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("mnthings:textures/bushman.png");
				}
			};
		});
	}
	public static class CustomEntity extends TameableEntity {
		public CustomEntity(FMLPlayMessages.SpawnEntity packet, World world) {
			this(entity, world);
		}

		public CustomEntity(EntityType<CustomEntity> type, World world) {
			super(type, world);
			experienceValue = 4;
			setNoAI(false);
		}

		@Override
		public IPacket<?> createSpawnPacket() {
			return NetworkHooks.getEntitySpawningPacket(this);
		}

		@Override
		protected void registerGoals() {
			super.registerGoals();
			this.targetSelector.addGoal(1, new NearestAttackableTargetGoal(this, PlayerEntity.class, false, true));
			this.goalSelector.addGoal(2, new MeleeAttackGoal(this, 4, false));
			this.targetSelector.addGoal(3, new HurtByTargetGoal(this).setCallsForHelp(this.getClass()));
			this.goalSelector.addGoal(4, new RandomWalkingGoal(this, 1));
			this.goalSelector.addGoal(5, new LookRandomlyGoal(this));
			this.goalSelector.addGoal(6, new SwimGoal(this));
			this.goalSelector.addGoal(7, new OwnerHurtByTargetGoal(this));
			this.goalSelector.addGoal(8, new OwnerHurtTargetGoal(this));
			this.goalSelector.addGoal(9, new FollowOwnerGoal(this, 1, (float) 5, (float) 2, false));
		}

		@Override
		public CreatureAttribute getCreatureAttribute() {
			return CreatureAttribute.UNDEFINED;
		}

		protected void dropSpecialItems(DamageSource source, int looting, boolean recentlyHitIn) {
			super.dropSpecialItems(source, looting, recentlyHitIn);
			this.entityDropItem(new ItemStack(Items.STICK, (int) (1)));
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.wooden_door.open"));
		}

		@Override
		public void playStepSound(BlockPos pos, BlockState blockIn) {
			this.playSound((net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.wool.break")), 0.15f, 1);
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.wood.break"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.wood.hit"));
		}

		@Override
		public boolean attackEntityFrom(DamageSource source, float amount) {
			if (source.getImmediateSource() instanceof PotionEntity)
				return false;
			if (source == DamageSource.CACTUS)
				return false;
			return super.attackEntityFrom(source, amount);
		}

		@Override
		public boolean processInteract(PlayerEntity sourceentity, Hand hand) {
			ItemStack itemstack = sourceentity.getHeldItem(hand);
			boolean retval = true;
			Item item = itemstack.getItem();
			if (itemstack.getItem() instanceof SpawnEggItem) {
				retval = super.processInteract(sourceentity, hand);
			} else if (this.world.isRemote) {
				retval = this.isTamed() && this.isOwner(sourceentity) || this.isBreedingItem(itemstack);
			} else {
				if (this.isTamed()) {
					if (this.isOwner(sourceentity)) {
						if (item.isFood() && this.isBreedingItem(itemstack) && this.getHealth() < this.getMaxHealth()) {
							this.consumeItemFromStack(sourceentity, itemstack);
							this.heal((float) item.getFood().getHealing());
							retval = true;
						} else if (this.isBreedingItem(itemstack) && this.getHealth() < this.getMaxHealth()) {
							this.consumeItemFromStack(sourceentity, itemstack);
							this.heal(4);
							retval = true;
						} else {
							retval = super.processInteract(sourceentity, hand);
						}
					}
				} else if (this.isBreedingItem(itemstack)) {
					this.consumeItemFromStack(sourceentity, itemstack);
					if (this.rand.nextInt(3) == 0 && !net.minecraftforge.event.ForgeEventFactory.onAnimalTame(this, sourceentity)) {
						this.setTamedBy(sourceentity);
						this.world.setEntityState(this, (byte) 7);
					} else {
						this.world.setEntityState(this, (byte) 6);
					}
					this.enablePersistence();
					retval = true;
				} else {
					retval = super.processInteract(sourceentity, hand);
					if (retval)
						this.enablePersistence();
				}
			}
			double x = this.getPosX();
			double y = this.getPosY();
			double z = this.getPosZ();
			Entity entity = this;
			return retval;
		}

		@Override
		protected void registerAttributes() {
			super.registerAttributes();
			if (this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.3);
			if (this.getAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(25);
			if (this.getAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(3);
			if (this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) == null)
				this.getAttributes().registerAttribute(SharedMonsterAttributes.ATTACK_DAMAGE);
			this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(3);
			if (this.getAttribute(SharedMonsterAttributes.KNOCKBACK_RESISTANCE) == null)
				this.getAttributes().registerAttribute(SharedMonsterAttributes.KNOCKBACK_RESISTANCE);
			this.getAttribute(SharedMonsterAttributes.KNOCKBACK_RESISTANCE).setBaseValue(0.01D);
			if (this.getAttribute(SharedMonsterAttributes.ATTACK_KNOCKBACK) == null)
				this.getAttributes().registerAttribute(SharedMonsterAttributes.ATTACK_KNOCKBACK);
			this.getAttribute(SharedMonsterAttributes.ATTACK_KNOCKBACK).setBaseValue(0.1D);
		}

		@Override
		public AgeableEntity createChild(AgeableEntity ageable) {
			CustomEntity retval = (CustomEntity) entity.create(this.world);
			retval.onInitialSpawn(this.world, this.world.getDifficultyForLocation(new BlockPos(retval)), SpawnReason.BREEDING,
					(ILivingEntityData) null, (CompoundNBT) null);
			return retval;
		}

		@Override
		public boolean isBreedingItem(ItemStack stack) {
			if (stack == null)
				return false;
			if (new ItemStack(Items.BONE_MEAL, (int) (1)).getItem() == stack.getItem())
				return true;
			return false;
		}
	}

	// Made with Blockbench 3.8.4
	// Exported for Minecraft version 1.15 - 1.16
	// Paste this class into your mod and generate all required imports
	public static class ModelBushman extends EntityModel<Entity> {
		private final ModelRenderer piernader;
		private final ModelRenderer piernaizq;
		private final ModelRenderer cuerpo;
		private final ModelRenderer stick;
		private final ModelRenderer stick_r1;
		private final ModelRenderer stick_r2;
		private final ModelRenderer stick_r3;
		private final ModelRenderer cabeza;
		private final ModelRenderer nose2_r1;
		private final ModelRenderer brazoder;
		private final ModelRenderer brazoizq;
		public ModelBushman() {
			textureWidth = 64;
			textureHeight = 64;
			piernader = new ModelRenderer(this);
			piernader.setRotationPoint(-1.5F, 18.1F, 0.5F);
			piernader.setTextureOffset(4, 0).addBox(-0.5F, -0.1F, -0.5F, 1.0F, 6.0F, 1.0F, 0.0F, false);
			piernaizq = new ModelRenderer(this);
			piernaizq.setRotationPoint(1.5F, 18.1F, 0.6F);
			piernaizq.setTextureOffset(0, 0).addBox(-0.5F, -0.1F, -0.6F, 1.0F, 6.0F, 1.0F, 0.0F, false);
			cuerpo = new ModelRenderer(this);
			cuerpo.setRotationPoint(0.0F, 14.0F, 0.5F);
			cuerpo.setTextureOffset(15, 14).addBox(-3.0F, 3.0F, -1.5F, 6.0F, 1.0F, 3.0F, 0.0F, false);
			cuerpo.setTextureOffset(0, 13).addBox(-3.0F, -4.2F, -1.5F, 6.0F, 1.0F, 3.0F, 0.0F, false);
			stick = new ModelRenderer(this);
			stick.setRotationPoint(0.0F, 14.0F, 0.5F);
			stick_r1 = new ModelRenderer(this);
			stick_r1.setRotationPoint(0.0F, 10.0F, -0.5F);
			stick.addChild(stick_r1);
			setRotationAngle(stick_r1, 0.3491F, 0.6545F, 0.0436F);
			stick_r1.setTextureOffset(0, 24).addBox(1.0F, -14.0F, 3.0F, 1.0F, 8.0F, 1.0F, 0.0F, false);
			stick_r2 = new ModelRenderer(this);
			stick_r2.setRotationPoint(0.0F, 10.0F, -0.5F);
			stick.addChild(stick_r2);
			setRotationAngle(stick_r2, 0.0F, 0.0F, -0.5236F);
			stick_r2.setTextureOffset(4, 24).addBox(4.0F, -13.0F, 0.0F, 1.0F, 8.0F, 1.0F, 0.0F, false);
			stick_r3 = new ModelRenderer(this);
			stick_r3.setRotationPoint(0.0F, 10.0F, -0.5F);
			stick.addChild(stick_r3);
			setRotationAngle(stick_r3, 0.0F, 0.0F, 0.4363F);
			stick_r3.setTextureOffset(8, 24).addBox(-5.0F, -13.0F, 0.0F, 1.0F, 8.0F, 1.0F, 0.0F, false);
			cabeza = new ModelRenderer(this);
			cabeza.setRotationPoint(0.1F, 9.7F, 0.5F);
			cabeza.setTextureOffset(0, 17).addBox(-2.1F, -4.7F, -1.5F, 4.0F, 4.0F, 3.0F, 0.0F, false);
			cabeza.setTextureOffset(11, 17).addBox(-0.5F, -0.7F, -0.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 0).addBox(-5.0F, -9.0F, -4.0F, 10.0F, 5.0F, 8.0F, 0.0F, false);
			cabeza.setTextureOffset(14, 18).addBox(-0.6F, -2.7F, -6.5F, 1.0F, 1.0F, 5.0F, 0.0F, false);
			nose2_r1 = new ModelRenderer(this);
			nose2_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			cabeza.addChild(nose2_r1);
			setRotationAngle(nose2_r1, 0.0F, 0.0F, -0.3927F);
			nose2_r1.setTextureOffset(0, 12).addBox(1.0F, -4.0F, -5.0F, 0.0F, 2.0F, 1.0F, 0.0F, false);
			brazoder = new ModelRenderer(this);
			brazoder.setRotationPoint(-3.1F, 10.5F, 0.4F);
			brazoder.setTextureOffset(39, 0).addBox(-0.9F, -0.5F, -0.4F, 1.0F, 8.0F, 1.0F, 0.0F, false);
			brazoizq = new ModelRenderer(this);
			brazoizq.setRotationPoint(3.2F, 10.5F, 0.5F);
			brazoizq.setTextureOffset(44, 0).addBox(-0.2F, -0.5F, -0.5F, 1.0F, 8.0F, 1.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			piernader.render(matrixStack, buffer, packedLight, packedOverlay);
			piernaizq.render(matrixStack, buffer, packedLight, packedOverlay);
			cuerpo.render(matrixStack, buffer, packedLight, packedOverlay);
			stick.render(matrixStack, buffer, packedLight, packedOverlay);
			cabeza.render(matrixStack, buffer, packedLight, packedOverlay);
			brazoder.render(matrixStack, buffer, packedLight, packedOverlay);
			brazoizq.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.brazoizq.rotateAngleX = MathHelper.cos(f * 0.6662F) * f1;
			this.brazoder.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
			this.piernaizq.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.nose2_r1.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.nose2_r1.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.cabeza.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.cabeza.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.piernader.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
		}
	}
}
